﻿/// <reference path="globals.js" />
/// <reference path="utils.js" />
/// <reference path="auth.js" />
/// <reference path="servercomm.js" />
/// <reference path="adNetwork.js" />
/// <reference path="userInterfaceBindings.js" />
/// <reference path="jquery-2.1.4.js" />
/// <reference path="jquery.mobile-1.4.5.js" />
/// <reference path="platformsFixup.js" />

var tmpFullPath;
var tempFs;
var tmpName = "tempfile.m4a";

function createTempFile() {

    if (isAndroid()) {
        window.resolveLocalFileSystemURL(cordova.file.dataDirectory, function (fileSystem) {
            tempFs = fileSystem;
            // get our file for recording
            tempFs.getFile(tmpName, { create: true }, function (fileEntry) {
                tmpFullPath = fileEntry.nativeURL;
            }, function (err) { trunicaAlert("Unable to get temp storage: " + err.code); });
        }, function (err) {
            trunicaAlert("Unable to get local file storage: " + err.code);
        });
    } else {
        window.requestFileSystem(window.TEMPORARY, 1024 * 1024, function (fileSystem) {
            tempFs = fileSystem;
            // get our file for recording
            tempFs.root.getFile(tmpName, { create: true, exclusive: false }, function (fileEntry) {
                tmpFullPath = fileEntry.fullPath;
            }, function (err) { trunicaAlert("Unable to get temp storage: " + err.code); });
        }, function (err) {
            trunicaAlert("Unable to get local file storage: " + err.code);
        });
    }
}

function getTempFileName() {
    return tmpFullPath;
}

function getTempFullFileName() {
    if (isAndroid())
        return tmpFullPath;
    else
        return (tempFs.root.toURL() + tmpName);
}

function clearTempFile() {
    tempFs.root.getFile(tmpName, { create: false, exclusive: false }, function (fileEntry) {
        fileEntry.remove(function () { }, function () { });
    });
    tempFs.root.getFile(tmpName, { create: true, exclusive: false }, function (fileEntry) { });
}