﻿/// <reference path="servercomm.js" />
/// <reference path="adNetwork.js" />
/// <reference path="userInterfaceBindings.js" />
/// <reference path="jquery-2.1.4.js" />
/// <reference path="jquery.mobile-1.4.5.js" />
/// <reference path="platformsFixup.js" />
/// <reference path="file.js" />

/// <reference group="Dedicated Worker" />

var lastPosition = null;
var watchID;
var POSITION_INTERVAL = 420000;
var lastSampleTime = 0;
var DISTANCE_KEY = "DST";

function getPosition() {
    watchID = navigator.geolocation.watchPosition(storePosition, errorPosition);
}

function stopPosition() {
    if (watchID)
        navigator.geolocation.clearWatch(watchID);
}

function storePosition(position) {
    lastPosition = position;
    
    // Only update after a while
    if ((Date.now() - lastSampleTime) > POSITION_INTERVAL && isLoggedIn()) {
        lastSampleTime = Date.now();

        // fail quietly
        serverRequest("POST", "/updateposition", "Latitude=" + encodeURIComponent(position.coords.latitude) + "&Longitude=" +
            encodeURIComponent(position.coords.longitude), null, function () { }, true, function () { }, false);
    }
}

function getLastPosition() {
    return lastPosition;
}

function errorPosition(err) {
    // fail silently in prod
    trunicaAlert("Unable to get location: " + err.message);
}

function getDistanceSetting() {
    closeByRadius = localStorage.getItem(DISTANCE_KEY);
    if (!closeByRadius) {
        closeByRadius = 50;
        localStorage.setItem(DISTANCE_KEY, closeByRadius)
    }

    return closeByRadius;
}

function setDistanceSetting(distance) {
    closeByRadius = distance;
    localStorage.setItem(DISTANCE_KEY, closeByRadius);
}