﻿/// <reference path="globals.js" />
/// <reference path="utils.js" />
/// <reference path="auth.js" />
/// <reference path="servercomm.js" />
/// <reference path="adNetwork.js" />
/// <reference path="userInterfaceBindings.js" />
/// <reference path="jquery-2.1.4.js" />
/// <reference path="jquery.mobile-1.4.5.js" />
/// <reference path="platformsFixup.js" />
/// <reference path="file.js" />
/// <reference path="position.js" />

var curProfileImageURI = null;

function loadProfileInfo() {
    getUserSettings(function () {
        $("#lblProfileUserName").html(userSettings[0].UserName);
        $("#txtProfileEmail").val(userSettings[0].eMail);
        $("#txtProfileDescription").val(userSettings[0].Description).keyup(); // keyup triggers resize
        if (userSettings[0].hasPic)
            $("#imgProfileImage").attr("src", SERVER_URL + SERVER_API_PATH + "/getprofileimage?token=" + accessToken +
                            "&UserID=" + userSettings[0].UserID + "&crc=" + userSettings[0].PictureCRC);
        else
            $("#imgProfileImage").attr("src", "images/profileImage70x70.png");
    });
}

function updateProfile() {
    serverRequest("POST","/updateuser","Description="+encodeURIComponent($("#txtProfileDescription").val()) +
        "&email=" + encodeURIComponent($("#txtProfileEmail").val()), null, function () { }, true, function(err) { trunicaAlert("Error updating profile: " + err);});
}

function changePassword() {
    var p1 = $("#txtChangePassword").val();
    var p2 = $("#txtChangePasswordVerify").val();

    // make sure passwords match
    if (p1 != p2) {
        trunicaAlert("Passwords do not match.");
        return;
    }

    // make sure password is valid
    if (p1.length > 0) {
        if (p1.length < 6) {
            trunicaAlert("Password is too short.  Password must be at least 6 characters long.");
            return;
        }
    }

    serverRequest("POST", "/updatepassword", "password=" + encodeURIComponent(p1), null, function () { trunicaAlert("Password changed!"); }, true,
        function (err) { trunicaAlert("Error updating password: " + err); }, false);
}

function selectProfileImage() {
    var edit = true;
    if (isAndroid())
        edit = false;

    var options = {
        quality: 75,
        targetHeight: 70,
        targetWidth: 70,
        allowEdit: edit,
        mediaType: Camera.MediaType.PICTURE,
        correctOrientation: true,
        destinationType: Camera.DestinationType.FILE_URI,
        encodingType: Camera.EncodingType.JPEG,
        sourceType: Camera.PictureSourceType.PHOTOLIBRARY
    };
     
    navigator.camera.getPicture(function (imageURI) {
        curProfileImageURI = imageURI;
        $("#imgProfileImage").attr("src", imageURI);
        setTimeout(uploadProfileImage, 150);
    }, function (message) {
        // user probably cancelled
        /* trunicaAlert("Error getting image: " + message); */
    }, options);
}

function uploadProfileImage() {
    var url = curProfileImageURI;

    if (!isWindows()) {
        url = url.replace(/url\(/, "");
        url = url.replace(/\)/, "");
    }

    // upload the channel image
    var ft = new FileTransfer();
    var options = new FileUploadOptions(null, null, null, null, null, null);
    options.fileKey = "file";
    options.fileName = url.substr(url.lastIndexOf('/') + 1);
    options.mimeType = "text/plain";
    fileParams.value1 = "test";
    fileParams.value2 = "param";
    options.params = fileParams;
    ft.upload(url, encodeURI(SERVER_URL + SERVER_API_PATH + "/uploadprofileimage?token=" + accessToken), function (r) {
       
    }, function (e) {
        trunicaAlert("Error Uploading profile image: " + e.code);
    }, options);
}