﻿/// <reference path="globals.js" />
/// <reference path="utils.js" />
/// <reference path="jquery-2.1.4.js" />
/// <reference path="jquery.mobile-1.4.5.js" />
/// <reference path="auth.js" />

// Functions to handle communications to our backend
//var SERVER_URL = "http://10.40.0.208";
//var SERVER_URL = "http://192.168.1.33";
var SERVER_URL = "http://prodshout.cloudapp.net";
//var SERVER_URL = "http://172.29.3.27";
//var SERVER_URL = "http://192.168.1.21";
var SERVER_API_PATH = "/api/v1";
var SERVER_TIMEOUT = 8000;
var MAX_MESSAGE_LENGTH = 30000;
var UPLOAD_TIMEOUT = 8000;

function serverRequest(type, command, param, errorMessage, successFunction, useAPI, errorFunction, cacheable) {
    if (useAPI === undefined) var useAPI = true;
    if (errorFunction === undefined) var errorFunction = function () { console.log(errorMessage); };
    if (cacheable == undefined) var cacheable = false;

    // send request to server
    var xmlhttp = new XMLHttpRequest();
    xmlhttp.onreadystatechange = function () {;
        if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
            successFunction(xmlhttp);
        } else if (xmlhttp.readyState == 4) {
            if (errorMessage)
                trunicaAlert(errorMessage);
            if (!(errorFunction === undefined))
                errorFunction(xmlhttp.responseText);
        }
    }
    var url = SERVER_URL + (useAPI == true ? SERVER_API_PATH : "") + command;
    var url2 = "";
    if (useAPI == true)
        url2 += "token=" + accessToken + "&";

    if (/GET/.test(type) && param)
        url2 += param;

    if (cacheable == false && /GET/.test(type)) {
        url2 += "&ts=" + Date.now();
    }
    url = url + (url2 != "" ? "?" + url2 : "");

    xmlhttp.open(type, url, true);
    xmlhttp.timeout = SERVER_TIMEOUT;
    xmlhttp.ontimeout = serverTimeout;
    if (/POST/.test(type)) {
        xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        xmlhttp.send(param);
    } else {
        xmlhttp.send();
    }
}

function serverTimeout() {
    trunicaAlert("Communication with server timed out.  Check your network connectivity");
}