﻿/// <reference path="globals.js" />
/// <reference path="utils.js" />
/// <reference path="auth.js" />
/// <reference path="servercomm.js" />
/// <reference path="adNetwork.js" />
/// <reference path="userInterfaceBindings.js" />
/// <reference path="jquery-2.1.4.js" />
/// <reference path="jquery.mobile-1.4.5.js" />
/// <reference path="platformsFixup.js" />
/// <reference path="file.js" />
/// <reference path="position.js" />
// http://go.microsoft.com/fwlink/?LinkID=290993&clcid=0x409


var GCM_SENDER_ID = '30257161885'; // Replace with your own ID.
var mobileServiceClient;
var pushNotification;
var userTag;
var MPNS_CHANNEL_PREFIX = "ShoutOut-";
var MPNS_CHANNEL_NAME = "shoutouthub";
var NOTIFICATION_SHOW_TIME = 3000;

// Create the Azure client register for notifications.
var registerNotifications = function (userName) {
    userTag = userName;

    mobileServiceClient = new WindowsAzure.MobileServiceClient(
        "https://shoutout.azure-mobile.net/",
        "gbvxbiLjqXZsOCFGRaltiMGyQmudhe12");

    // Define the PushPlugin.
    pushNotification = window.plugins.pushNotification;
    // Platform-specific registrations.
    if (device.platform == 'android' || device.platform == 'Android') {
        // Register with GCM for Android apps.
        pushNotification.register(successHandler, errorHandler,
          {
              "senderID": GCM_SENDER_ID,
              "ecb": "onGcmNotification"
          });
    } else if (device.platform === 'iOS') {
        // Register with APNS for iOS apps.
        pushNotification.register(tokenHandler, errorHandler,
            {
                "badge": "true",
                "sound": "true",
                "alert": "true",
                "ecb": "onApnsNotification"
            });
    } else if (/windows/.test(device.platform) || /Win/.test(device.platform)) {
        registerMPNS();
    }
}

var unregisterNotifications = function () {
    if (isWindows()) {
        hub.mpns.unregister(curURI, [userTag], "myTemplate");
    }
    else
        pushNotification.unregister(function () { }, function (err) { console.log(err); });
}

// Handle a MPNS notification.
function registerMPNS() {
    // Register with MPNS for Windows 8 notifications
    pushNotification.register(
        MPNSChannelHandler,
        errorHandler,
        {
            "channelName": MPNS_CHANNEL_NAME,
            "ecb": onMPNSNotification,
            "uccb": MPNSChannelHandler,
            "errcb": errorHandler
        });
}

var WP8Hub;
var curURI;
function MPNSChannelHandler(event) {
    if (event.uri == "")
        setTimeout(registerMPNS, 5000);
    else {
        // Create the integrated Notification Hub client.
        hub = new NotificationHub(mobileServiceClient);
        curURI = event.uri;

        // This is a template registration.
        var template = "<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
            "<wp:Notification xmlns:wp=\"WPNotification\">" +
                "<wp:Toast>" +
                    "<wp:Text1>$(message)</wp:Text1>" +
                "</wp:Toast>" +
            "</wp:Notification>";

        // Register for notifications.
        // (channelUri, ["tag1","tag2"] , templateName, templateBody)
        hub.mpns.register(event.uri, [userTag], "myTemplate", template);
    }
}

function onMPNSNotification(event) {
    alert("MSG: " + event.message);
}

// Handle a GCM notification.
function onGcmNotification(e) {
    switch (e.event) {
        case 'registered':
            // Handle the registration.
            if (e.regid.length > 0) {
                //console.log("gcm id " + e.regid);
                if (mobileServiceClient) {
                    // Template registration.
                    var template = '{ "data" : {"message":"$(message)", "title":"$(title)", "msgcnt": "$(badge)"} }';
                    // Register for notifications.
                    mobileServiceClient.push.gcm.registerTemplate(e.regid,
                      "myTemplate", template, [userTag])
                      .done(function () {
                          // everything went ok
                          console.log("SUCCESS: Registered for notifications");
                      });
                    /*mobileServiceClient.push.gcm.registerTemplate(e.regid,
                      "myTemplate", template, null)
                      .done(function () {
                          alert('Registered template with Azure!');
                      }).fail(function (error) {
                          alert('Failed registering with Azure: ' + error);
                      });*/
                }
            }
            break;
        case 'message':
            if (e.foreground) {
                handleNotificationMessage(e.payload.message);
            } else { // need to update notification count on our icon
            }
            break;
        case 'error':
            trunicaAlert('Google Cloud Messaging error: ' + e.message);
            break;
        default:
            trunicaAlert('An unknown GCM event has occurred');
            break;
    }
}

// GCM registration success handler.
function successHandler(result) {
    //console.log('NOTIFICATION SUCCESS: ' + result);
}
// 
function errorHandler(error) {
    console.log('NOTIFICATION ERROR: ' + error);
}

// Receive the APNS token.
function tokenHandler(result) {
    if (mobileServiceClient) {
        // This is a template registration.
        var template = '{"aps":{"alert":"$(message)", "sound":"default", "badge": "#(badge)" }}';
        // Register for notifications.
        // (deviceId, templateName, templateBody, expiration, ["tag1","tag2"]) // template params w/ tags
        mobileServiceClient.push.apns.registerTemplate(result, 'myTemplate', template, [userTag]).done(function () {
            console.log("SUCCESS: Registered for notifications");
        }).fail(function (error) {
            alert('Failed registering with APNS: ' + error);
        });
    }
}

function onApnsNotification(event) {;
    if (event.alert) {
        handleNotificationMessage(event.alert);
    }
    if (event.sound) {
        var snd = new Media(event.sound);
        snd.play();
    }
    if (event.badge) {
        setBadgeCount(event.badge);
    }
}

function handleNotificationMessage(msg) {
    // if we are recording then sleep for 10 seconds and retry
    if (inRecord == 1) {
        console.log("Received notification during record... sleeping 10 seconds.");
        setTimeout(function () { handleNotificationMessage(msg); }, 10000);
        return;
    }

    // display an indicator that eventually goes away
    newMessageNotification(msg);
}

var setBadgeCount = function (count) {
    pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, count)
}

function newMessageNotification(msg) {
    var user = msg.substring(0, msg.indexOf(" "));
    var description = msg.substring(msg.lastIndexOf(" ")+1, msg.length);

    playNotify(function () {
        $("#lblNotifyUserName").html(user);
        $("#lblNotifyDescription").html(description);
        $("#popupNotify").popup("open");
        setTimeout(function () { $("#popupNotify").popup("close"); }, NOTIFICATION_SHOW_TIME);
    });
}

// FOLLOWING adapted from https://raw.githubusercontent.com/Azure/mobile-services-samples/master/TodoListNotifications/phonegap/platforms/wp8/www/js/NotificationHub.js
// TODO: can switch this back to using deferred since we have jquery
NotificationHub = function (mobileClient) {
    // Set the client to use to register for push.
    this.mobileClient = mobileClient;

    this.mpns = new mpns(this);
};

// #region CRUD ops
// Create registration ID--payload on upsert.
var createRegistrationId = function (hub) {

    // Variables needed to make the request to the mobile service.
    var method = "POST";
    var uriFragment = "/push/registrationids";

    // Send a Notification Hubs registration request to the Mobile Service.
    hub.mobileClient._request(method, uriFragment, null, null, null,
        function (error, response) {
            if (error) {
                console.log("Error: " + error);
            } else {
                // Get the unique registration ID from the Location header.
                var location = response.getResponseHeader("Location");
                var regex = /\S+\/registrations\/([^?]+).*/;
                var regId = regex.exec(location)[1];

                // BRL...
                // Store registration info with the returned ID.
                var regKey = buildRegKey(hub, registration);
                var regInfo = getFromContainer(regKey);
                regInfo = {};
                regInfo.regId = regId;
                regInfo.deviceToken = registration.deviceToken;

                storeInContainer(regKey, regInfo);
                getFromContainer(regKey);

                updateRegistration(hub, regId, registration);
            }
        });
};

// Update an existing registration--includes payload.
var updateRegistration = function (hub, regId, registration) {

    // Variables needed to make the request to the mobile service.
    var registrationPayload = buildCreatePayload(registration);
    var method = "PUT";
    var uriFragment = "/push/registrations/" + regId;

    // Send a Notification Hubs registration update to the Mobile Service.
    hub.mobileClient._request(method, uriFragment, registrationPayload, null,
        null, function (error, response) {
            if (error) {
                console.log("Error: " + error);
            } else {
                console.log("Updated registration: " + regId);
            }
        });
};

var deleteRegistration = function (hub, regId) {

    var method = "DELETE";
    var uriFragment = "/push/registrations/" + regId;

    // Send a Notification Hubs registration update to the Mobile Service.
    hub.mobileClient._request(method, uriFragment, null, null,
        null, function (error, response) {
            if (error) {
                console.log("Error: " + error);
            } else {
                console.log("Deleted registration");
            }
        });
};

// Create registration as an insert + update (POST + PUT).
var createRegistration = function (hub, registration) {
    return createRegistrationId(hub).then(function (regId) {
        return updateRegistration(hub, regId, registration).then(function () {
            return regId;
        });
    });
};

// #endregion CRUD ops

// #region helper functions
var buildRegKey = function (hub, registration) {

    var tileKey = 'application';
    if (typeof registration.tileId !== 'undefined') {
        tileKey = registration.tileId;
    }

    // create key
    var regKey = hub.mobileClient.applicationUrl + tileKey;
    if (registration.templateName) {
        regKey = regKey + '/' + registration.templateName;
    }
    return regKey;
};

var buildCreatePayload = function (registration) {

    // The payload matches the registration object, so all 
    // we need to do is add any extra info not part of the registration.
    var payload = registration;

    // Add static headers required by MPNS template
    if (payload.platform === 'mpns' && payload.templateBody) {

        // Add the MPNS headers required for a template registration.
        payload.headers = { "X-WindowsPhone-Target": "toast", "X-NotificationClass": "2" };
    }

    // Return the payload as a string.
    return JSON.stringify(payload);
};
// #endregion helper functions

// #region local storage
// object: {regId: '', deviceToken: ''}
var storeInContainer = function (key, object) {
    localStorage.setItem(key, JSON.stringify(object));
};

var deleteFromContainer = function (key) {
    localStorage.removeItem(key);
};

var getFromContainer = function (key) {

    if (typeof localStorage.getItem(key) === 'string') {
        return JSON.parse(localStorage.getItem(key));
    }
    return undefined;
};
// #endregion local storage

// #region public API
var register = function (hub, registration) {
    // Build the key used to store info in local storage,
    // then get the stored registration--if it exists.
    var regKey = buildRegKey(hub, registration);
    var regInfo = getFromContainer(regKey);
    var retries = 0;

    if (typeof regInfo !== 'undefined') {
        // If we find stored registration, then this should be 
        // an update of the existing registration.
        updateRegistration(hub, regInfo.regId, registration).then(
            function () {
            }, function (error) {
                // if not exists / recreate
                if ((error === '404' || error === '410') && retries < 2) {
                    createRegistration(hub, registration);
                } else {
                    //deferred.reject(error);
                }
            }).then(function () {
                // update regInfo with new location
                //regInfo.location = location;
                // Store the latest device token.
                regInfo.deviceToken = registration.deviceToken;
                storeInContainer(regKey, regInfo);

                //deferred.resolve();
            }, function (error) {
                //deferred.reject(error);
            });
    } else {
        // create new registration.
        return createRegistration(hub, registration).then(
            function (regId) {
                alert("createregistration then");
                // Store registration info with the returned ID.
                regInfo = {};
                regInfo.regId = regId;
                regInfo.deviceToken = registration.deviceToken;

                storeInContainer(regKey, regInfo);
                getFromContainer(regKey);

                updateRegistration(hub, regId, registration);
            }, function (error) {
                //deferred.reject(error);
            });
    }
};

var unregister = function (hub, registration) {
    var regKey = buildRegKey(hub, registration);

    var regInfo = getFromContainer(regKey);
    if (typeof regInfo === 'undefined') {
        //deferred.resolve();
    }

    // delete registration
    deleteRegistration(hub, regInfo.regId);
};

var mpns = function (hub) {
    this.hub = hub;
};

var registration;

mpns.prototype = {

    register: function (channel, tags, templateName, templateBody) {
        registration = {
            platform: "mpns",
            deviceId: channel,
            tags: tags,
            templateName: templateName,
            templateBody: templateBody
        };
        return this.hub._register(this.hub, registration);
    },

    unregister: function (channel, tags, templateName) {
        return this.hub._unregister(this.hub, {
            platform: "mpns",
            deviceId: channel,
            tags: tags,
            templateName: templateName
        });
    }
};

NotificationHub.prototype = {
    _register: register,
    _unregister: unregister,

    mpns: this.mpns
};
// #endregion public API