﻿/// <reference path="globals.js" />
/// <reference path="utils.js" />
/// <reference path="auth.js" />
/// <reference path="servercomm.js" />
/// <reference path="adNetwork.js" />
/// <reference path="userInterfaceBindings.js" />
/// <reference path="jquery-2.1.4.js" />
/// <reference path="jquery.mobile-1.4.5.js" />

var SHOUT_CHANNEL_ID = null;
var lastMessageScore = null;
var timeLeft;
var timerCountdown = null;
var shoutRecorder = null;
var previewPlayer = null;
var shoutLength;
var playShoutLength;
var startRecordTime;
var currentListName = "#popular";
var shoutPlayer = null;
var sliderPos = 0;
var curMessageID;
var sliderTimeout = null;
var curHolderID;
var nextHolderID = 0;
var lastOrderBy = " Likes Desc";
var currentTab = "#navPopular";
var inRecord = 0;

function refreshCurrentTab() {
    stopAllPlayback();
    if (!SHOUT_CHANNEL_ID)
        getShoutChannelInfo(refreshCurrentTab);
    else
        $(currentTab).click();
}

function loadCloseBy() {
    showSpinner();
    stopAllPlayback();
    if (!SHOUT_CHANNEL_ID || SHOUT_CHANNEL_ID == null)
        getShoutChannelInfo(loadCloseBy);
    else {
        // get the next 100 close messages
        currentListName = "#closeBy";
        clearMessages(currentListName);
        lastOrderBy = " Distance ASC";

        var Latitude = 0.0;
        var Longitude = 0.0
        var pos = getLastPosition();
        if (pos) {
            Latitude = pos.coords.latitude;
            Longitude = pos.coords.longitude;
        }
        serverRequest("GET", "/closemessages", "ChannelID=" + SHOUT_CHANNEL_ID + "&ShowFlagged=1&OrderBy='" + lastOrderBy + "'" +
            "&Latitude=" + Latitude + "&Longitude=" + Longitude + "&Distance=" + getDistanceSetting(), "Error getting channel messages.",
            listLoader, true, function (err) { trunicaAlert("Error loading shouts: " + err); }, false);
    }
}

function loadPopular() {
    showSpinner();
    stopAllPlayback();
    if (!SHOUT_CHANNEL_ID || SHOUT_CHANNEL_ID == null)
        getShoutChannelInfo(loadPopular);
    else {
        // get the next 50 popular messages
        loadMessagesToList("#popular", "Likes Desc LIMIT 100");
    }
}

function loadLatest() {
    showSpinner();
    stopAllPlayback();
    if (!SHOUT_CHANNEL_ID || SHOUT_CHANNEL_ID == null)
        getShoutChannelInfo(loadLatest);
    else {
        // get the next 50 latest messages
        loadMessagesToList("#latest", " Created Desc LIMIT 100");
    }
}

function loadMessagesToList(lstName, orderBy) {
    currentListName = lstName;
    clearMessages(lstName);
    lastOrderBy = orderBy;
    serverRequest("GET", "/getchannelmessages", "channelid=" + SHOUT_CHANNEL_ID + "&ShowFlagged=1&OrderBy='" + orderBy + "'", "Error getting channel messages.", listLoader, true,
        function (err) { trunicaAlert("Error loading shouts: " + err); }, false);
}

function clearMessages(lstName) {
    $(lstName).empty();
}

function loadMyShouts(lstName) {
    showSpinner();
    stopAllPlayback();
    currentListName = lstName;
    clearMessages(lstName);
    serverRequest("GET", "/activemessages", null, "Error loading my shouts.", listLoader, true,
        function (err) { trunicaAlert("Error loading my shouts: " + err); });
}

function loadFavorites(lstName) {
    showSpinner();
    stopAllPlayback();
    currentListName = lstName;
    clearMessages(lstName);
    serverRequest("GET", "/getfavoritemessages", null, "Error loading favorite shouts.", listLoader, true,
        function (err) { trunicaAlert("Error loading favorite shouts: " + err); }, false);
}

function loadSearchToList(lstName, orderBy) {
    showSpinner();
    stopAllPlayback();
    currentListName = lstName;
    clearMessages(lstName);
    serverRequest("GET", "/searchmessages", "ChannelID=" + SHOUT_CHANNEL_ID + "&ShowFlagged=1&OrderBy='" + orderBy + " LIMIT 100'" + "&SearchString='" + $("#txtSearchField").val() + "'",
        "Error getting channel messages.", listLoader, true,
        function (err) { trunicaAlert("Error searching shouts!"); }, false);
}

function listLoader(xmlhttp) {
    if (/NO MATCH/.test(xmlhttp.responseText))  // TODO: THIS NEEDS TO BE DONE BETTER AS this could match actual results.
    {
        hideSpinner();
        return;
    }

    var p = JSON.parse(xmlhttp.responseText);

    // fill our list
    for (var i = 0; i < p.length; i++) {
        nextHolderID++;
        element = "<div data-role='collapsible' class='ui-collapsible ui-collapsible-themed-content ui-collapsible-collapsed  contentCompress' " +
                  " data-enhanced='true' data-collapsed-icon='audio' " + 
                  " data-expanded-icon='carat-u' alt='" + p[i].MessageID + "' style='clear:both' id=" + nextHolderID + "> " +
                  "<h4 class='ui-collapsible-heading ui-collapsible-heading-collapsed'>" +
                  "<a href='#' class='ui-collapsible-heading-toggle ui-btn ui-btn-icon-right ui-icon-audio ui-btn-inherit ui-mini'>" +
                  "<span class='imgAlignSmall'><img class='shoutListImage' ";
        if (p[i].hasPic)
           element += "src='" + SERVER_URL + "/getuserprofileimage?UserID=" + p[i].UserID + "&crc=" + p[i].PictureCRC + "' />";
       else
            element += "src='images/profileImage30x30.png' />";
        element += "</span><label class='shoutListUserName" + (p[i].MessageHeard != null ? "" : " notHeard") + "'>" + p[i].UserName +
                   "</label><label class='shoutListTitle" + (p[i].MessageHeard != null ? "" : " notHeard") + "'>" + p[i].Description + "</label>" +
                   "<label class='shoutListScore' id='lblSmallLegit-" + nextHolderID + "'>" + (p[i].Likes > 0 ? p[i].Likes + " Legit</label>" : "</label>") +
                   "<span class='ui-collapsible-heading-status'> click to expand contents</span></a></h4>" +
                   "<div class='ui-collapsible-content ui-body-inherit ui-collapsible-content-collapsed' aria-hidden='true'>" +
                   "<p class='mediaArea'><span class='full-width-slider mediaSlider' id='slider-span-" + nextHolderID + "'>" +
                    "<label for='slider-" +nextHolderID + "' class='ui-hidden-accessible mediaItem'>Slider</label></span><br /><span style='float:left'>" +
                    "<button class='ui-btn ui-btn-inline ui-mini ui-corner-all mediaItem' id='whack-" + nextHolderID + "' alt='" + p[i].MessageID + "' onclick='shoutWhack(" + p[i].MessageID + "," + nextHolderID + ");'>Whack</button>" +
                    "<a href='#popupReport' data-rel='popup' data-position-to='window' data-transition='pop' " +
                    "class='ui-btn ui-btn-inline ui-mini ui-corner-all ui-icon-alert ui-btn-icon-notext mediaItem' style='left:5px' alt='" + p[i].MessageID + "'></a>" +
                    "</span><span class='mediaItemRight'><a href='#popupUserInfo' data-rel='popup' data-position-to='window' style='right:10px' data-transition='pop' onclick='shoutOwnerInfo(" + p[i].UserID + ");' " +
                    "class='ui-btn ui-btn-inline ui-mini ui-corner-all ui-icon-user ui-btn-icon-notext mediaItem' alt='" + p[i].MessageID + "'></a> " +
                    "<button class='ui-btn ui-btn-inline ui-mini ui-corner-all ui-icon-heart ui-btn-icon-notext mediaItem " + (p[i].IsFavorite != null ? "favorite" : "") + "' style='right:10px' id='fav-" + nextHolderID + "' onclick='shoutToggleFavorite(" + p[i].MessageID + "," + nextHolderID + ");' alt='" + p[i].IsFavorite + "'></button>" +
                    (p[i].UserID == userSettings[0].UserID ?
                    "<a href='#popupDeleteShout' data-rel='popup' data-position-to='window' data-transition='pop' " + 
                    "class='ui-btn ui-btn-inline ui-mini ui-corner-all ui-icon-delete ui-btn-icon-notext mediaItem' style='right:5px' alt='" + p[i].MessageID + "'></a>"
                    :
                    "<a href='#popupReShout' data-rel='popup' data-position-to='window' data-transition='pop' " + 
                    "class='ui-btn ui-btn-inline ui-mini ui-corner-all ui-icon-action ui-btn-icon-notext mediaItem' style='right:5px' alt='" + p[i].MessageID + "'></a>") +
                    "<button class='ui-btn ui-btn-inline ui-mini ui-corner-all mediaItem' id='legit-" + nextHolderID + "' alt='" + p[i].MessageID + "' onclick='shoutLegit(" + p[i].MessageID + "," + nextHolderID + ");'>Legit</button>" +
                    "</span></p></div></div>";
  
        $(currentListName).append(element);
        $(currentListName).children(":last").collapsible();
        
        $(currentListName).children(":last").on("collapsibleexpand", playShout);
        $(currentListName).children(":last").on("collapsiblecollapse", function (event, ui) { if (shoutPlayer) shoutPlayer.stop(); } );

        //$("#" + nextHolderID).on("collapsibleexpand", playShout);
        //$("#" + nextHolderID).on("collapsiblecollapse", function (event, ui) { if (shoutPlayer) shoutPlayer.stop(); });

        // add the slider
        $("<input type='range' data-type='range' min='1' max='15' value='0' data-highlight='true' class='ui-hidden-accessible mediaItem' id='slider-" + nextHolderID + "' " +
            " alt='" + p[i].MessageID + "'>").appendTo("#slider-span-" + nextHolderID).slider();
        $("#slider-span-" + nextHolderID).children(":last").on("slidestop", sliderMove);
        $("<a href='#popupShoutInfo' id='btnInfo-" + nextHolderID + "' alt='" + p[i].MessageID + "' data-rel='popup' data-position-to='window' data-transition='pop'" +
          " class='ui-btn ui-btn-inline ui-mini ui-corner-all ui-icon-info ui-btn-icon-notext mediaInfoButton'>").appendTo("#slider-span-" + nextHolderID);
        $("#slider-span-" + nextHolderID).children(":last").on("click", showShoutInfo);
    }
    hideSpinner();
}

function stopPlayback(event, ui) {
    if (shoutPlayer) {
        shoutPlayer.stop();
        shoutPlayer.release();
        if (sliderTimeout)
            clearTimeout(sliderTimeout);
        sliderTimeout = null;
        shoutPlayer = null;
        sliderPos = 0;
    }
}

function stopAllPlayback() {
    stopPlayback(null, null);
    stopPreview();
    $("#" + curHolderID).collapsible("collapse");
}

function playShout (event, ui) {
    var MessageID = $(this).attr("alt");
    curHolderID = $(this).attr("id");
    $(this).find(".shoutListUserName").removeClass("notHeard");
    $(this).find(".shoutListTitle").removeClass("notHeard");
    $("#popupTest").popup("open");
    stopPlayback(event, ui);

    var url = SERVER_URL + SERVER_API_PATH + "/getmessagedata?token=" + accessToken + "&MessageID=" + MessageID;
    shoutPlayer = new Media(url, function () { },
        function (err) {
            if (err.code != 0) trunicaAlert("Error playing shout audio: " + err.code);
        });

    serverRequest("GET", "/getmessagelength", "MessageID=" + MessageID, "Could not get shout length!",
        function (results) {
            // handle the slider
            playShoutLength = JSON.parse(results.responseText)[0].Length;
            sliderPos = 0;
            curMessageID = MessageID;
            $("#slider-" + curHolderID).attr("max", playShoutLength + 1).slider("refresh");
            $("#slider-" + curHolderID).val(sliderPos);
            $("#slider-" + curHolderID).slider("refresh");
            sliderMover();

            // play the message
            shoutPlayer.play();
        }, true,
        function (err) { trunicaAlert("Error getting shout length: " + err); }, false);
}

function sliderMover() {
    sliderPos++;
    $("#slider-" + curHolderID).val(sliderPos);
    $("#slider-" + curHolderID).slider("refresh");
    if (sliderPos <= playShoutLength)
        sliderTimeout = setTimeout(sliderMover, 1000);
    else {
        sliderTimeout = null;
        // bump listen count?  Should only do for full plays?
        serverRequest("POST", "/setheard", "MessageID=" + curMessageID + "&MessageIndex=" + Math.max(sliderPos, playShoutLength), "Error updating listen count",
            function () { }, true, function (err) { trunicaAlert("Error updating listen count: " + err); }, false);
    }
}

function sliderMove(event, ui) {
    if (shoutPlayer) {
        shoutPlayer.stop();
        if (sliderTimeout)
            clearTimeout(sliderTimeout);
        sliderPos = ($("#slider-" + curHolderID).val() - 1);
        shoutPlayer.play();
        shoutPlayer.seekTo(sliderPos * 1000);

        sliderMover();
    }
}


function showShoutInfo(event, ui) {
    var MessageID = $(this).attr("alt");

    getShoutInfo(MessageID, function (data) {
        // fill in our fields in the popup
        $("#lblShoutInfoUserName").html(data[0].UserName);
        $("#lblShoutAt").html(data[0].Created);
        $("#lblShoutDescription").html(data[0].Description);
        $("#lblListenCount").html(" " + data[0].ListenCount + "&nbsp;&nbsp;&nbsp;")
        $("#lblLegit").html(data[0].Likes + " Legit");
        $("#lblWhack").html(data[0].Dislikes + " Whack");
        $("#lblFavorites").html(" " + data[0].FavoriteCount + "&nbsp;&nbsp;&nbsp;");
        $("#lblReshouts").html(" " + data[0].RelayCount);

        getShoutTags(MessageID, function (tags) { $("#lblShoutTags").html(tags); });
    });
}

function getShoutInfo(MessageID, callback) {
    serverRequest("GET", "/getmessage", "MessageID=" + MessageID, null,
        function (results) {
            var data = JSON.parse(results.responseText);
            callback(data);
        }, true,
        function (err) {
            trunicaAlert("Could not get Shout Out! info: " + err);
        }, false);
}

function getShoutTags(MessageID, callback) {
    serverRequest("GET", "/getmessagetags", "MessageID=" + MessageID, null,
        function (tagResults) {
            var tags = JSON.parse(tagResults.responseText);

            var tagString = "";
            for (var i = 0; i < tags.length; i++)
                tagString += tags[i].Name + " ";
            callback(tagString);
        }, true,
        function (err) {
            trunicaAlert("Could not get Shout Out! tags: " + err);
        }, true);
}

function getShoutChannelInfo(callback) {
    serverRequest("GET", "/getchannelbyname", "name=shout", "Error getting shout channel",
        function (results) {
            SHOUT_CHANNEL_ID = JSON.parse(results.responseText)[0].ChannelID;
            if (callback) callback();
        }, true,
        function (err) { trunicaAlert(err); },
        false);
}

function resetRecordWindow() {
    $("#lblRecordingTitle").text("Get ready!");
    $("#lblTimeLeft").text("Please wait...");

    // setup stop record button
    $("#btnStopPlayShout").attr("src", "images/stopRecordButton70x70.png");
}

function recordShout() {
    //clearTempFile();
    // play chime and have the recording start when it is finished.
    stopAllPlayback();
    playChime(startRecord);
}

function startRecord() {
    chimePlayer.release();

    inRecord = 1;
    timeLeft = 31;
    shoutLength = 0;
    $("#lblRecordingTitle").text("Recording!");
    $("#lblRecordingTitle").toggleClass("blink", true);
    clearCountdown();

    shoutRecorder = new Media(getTempFileName(), function () {
        inRecord = 0;
        shoutLength = (Date.now() - startRecordTime) / 1000;
        shoutRecorder.release();
        finishShout();
    }, function (err) { trunicaAlert("Error Recording Audio: " + err.code); }, 
        function (mediaStatus) { });
    $("#btnStopPlayShout").off("click");
    $("#btnStopPlayShout").on("click", function () { shoutRecorder.stopRecord(); });
    startRecordTime = Date.now();
   
    shoutRecorder.startRecord();
    countDown();
}

function countDown() {
    timeLeft--;
    $("#lblTimeLeft").text(timeLeft + " seconds left");
    if (timeLeft)
        timerCountdown = setTimeout(function () { countDown(); }, 1000);
    else
        shoutRecorder.stopRecord();
}

function finishShout() {    
    $("#lblTimeLeft").text("Done");
    $("#lblRecordingTitle").text("Shout Out Recorded!");
    $("#lblRecordingTitle").toggleClass("blink", false);

    clearCountdown();

    // change stop button to play button
    $("#btnStopPlayShout").attr("src", "images/playButton70x70.png");
    $("#btnStopPlayShout").off("click");
    $("#btnStopPlayShout").on("click", function () { previewShout(); });
    $("#")
}

function previewShout() {
    $("#btnStopPlayShout").attr("src", "images/stopButton70x70.png");
    previewPlayer = new Media(getTempFileName(),
        function () {
            previewPlayer.release();
            previewPlayer = null;
            $("#btnStopPlayShout").off("click");
            $("#btnStopPlayShout").on("click", function () { previewShout(); });
            $("#btnStopPlayShout").attr("src", "images/playButton70x70.png");
        },
        function (err) { trunicaAlert("Error previewing shout:" + err.code); });
    $("#btnStopPlayShout").off("click");
    $("#btnStopPlayShout").on("click", function () { previewPlayer.stop(); });
    previewPlayer.play();
}

function cancelShout() {
    if (shoutRecorder)
        shoutRecorder.stopRecord();
    clearCountdown();
    stopPreview();
    $("#btnStopPlayShout").off("click");
    $("#popupRecord").popup("close");
}

function clearCountdown() {
    if (timerCountdown)
        clearTimeout(timerCountdown);
    timerCountdown = null;
}

function uploadShout() {
    if (shoutRecorder)
        shoutRecorder.stopRecord();
    if (shoutLength == 0)
        shoutLength = (Date.now() - startRecordTime) / 1000; // due to async need to make sure this is set... need to look at deferred...
    finishShout();
    stopPreview();
    uploadFile();
}

function stopPreview() {
    if (previewPlayer)
        previewPlayer.stop();
}

function uploadFile() {
    var ft = new FileTransfer();
    var location = getLastPosition();
    var format = "aac";

    ft.upload(getTempFullFileName(), encodeURI(SERVER_URL + SERVER_API_PATH + "/uploadmessage?token=" + accessToken +
        "&channelid=" + SHOUT_CHANNEL_ID + "&length=" + encodeURIComponent(shoutLength) +
        "&description=" + encodeURIComponent($("#txtShoutDescription").val()) + "&expiretime=null" +
        "&tags='" + encodeURIComponent($("#txtShoutTags").val()) + "'&makedefault=false" + "&audioformat=" + format + 
        (!location ? "&position=uselast" : "&latitude=" + encodeURIComponent(location.coords.latitude) + "&longitude=" + encodeURIComponent(location.coords.longitude))),
        function (results) {
            if (/SUCCESS/.test(results.response)) {
                var MessageID = results.response.substr(results.response.lastIndexOf(":") + 1);
                $("#btnStopPlayShout").off("click");
                $("#popupRecord").popup("close");

                window.plugins.socialsharing.share(buildShareMessage($("#txtShoutDescription").val(), $("#txtShoutTags").val()),
                                                    "Check out what I said in my Shout Out!",
                                                    null,
                                                    ("http://prodshout.cloudapp.net/getshout/" + MessageID));
                //window.plugins.socialsharing.shareViaFacebookWithPasteMessageHint('Message via Facebook', null /* img */, "www.trunica.net" /* url */, 'My shout description!',
                //    function () { }, function (errormsg) { trunicaAlert(errormsg); });
                //<button onclick="window.plugins.socialsharing.share('Message, image and link', null, 'https://www.google.nl/images/srpr/logo4w.png', 'http://www.x-services.nl')">
            }
        },
        function (e) { trunicaAlert("Error Uploading Message: " + e.code); });
}

function shoutLegit(MessageID, HolderID) {
    $("#legit-" + HolderID).css({ "color": "green" });
    $("#whack-" + HolderID).css({ "color": "black" });
    playLegit(function () {
        serverRequest("POST", "/likemessage", "MessageID=" + MessageID, "Could not legit shout!",
            function (results) {
                if (!/Already/.test(results.responseText))
                    incrementSmallLegit(HolderID);
            },
            true, function (err) { trunicaAlert("Unable to legit shout: " + err); });
    });
}

function shoutWhack(MessageID, HolderID) {
    $("#legit-" + HolderID).css({ "color": "black" });
    $("#whack-" + HolderID).css({ "color": "red" });
    playWhack(function () {
        serverRequest("POST", "/dislikemessage", "MessageID=" + MessageID, "Could not whack shout!",
            function (results) {
                if (/Removed/.test(results.responseText))
                    decrementSmallLegit(HolderID);
            }, true, function (err) { trunicaAlert("Unabel to whack shout: " + err); });
    });
}

function incrementSmallLegit(HolderID) {
    var c = $("#lblSmallLegit-" + HolderID).html();

    if (c && c != "")
        c = parseInt(c) + 1;
    else
        c = 1;

    $("#lblSmallLegit-" + HolderID).html(c + " Legit");
}

function decrementSmallLegit(HolderID) {
    var c = $("#lblSmallLegit-" + HolderID).html();

    if (c && c != "") {
        c = parseInt(c) - 1;
        if (c > 0)
            $("#lblSmallLegit-" + HolderID).html(c + " Legit");
        else
            $("#lblSmallLegit-" + HolderID).html("");
    }
}

function reshoutShout() {
    getShoutInfo(curMessageID, function (data) {
        getShoutTags(curMessageID, function (tags) {
            serverRequest("POST", "/relaymessage", "MessageID=" + curMessageID, null,
                function (results) {
                    $("#popupReShout").popup("close");
                    var MessageID = results.response.substr(results.response.lastIndexOf(":") + 1);

                    window.plugins.socialsharing.share(buildShareMessage(data[0].Description, tags),
                                                        "Check out what I said in my Shout Out!",
                                                        null,
                                                        ("http://prodshout.cloudapp.net/getshout/" + MessageID));
                }, true,
                function (err) { trunicaAlert("Error re-shoutoing shout: " + err); }, false);
        });
    });
}

function reportShout() {
    serverRequest("POST", "/flagmessage", "MessageID=" + curMessageID, null,
        function (results) { $("#popupReport").popup("close"); trunicaAlert("This Shout OUT! has been reported!"); }, true,
        function (err) { trunicaAlert("Error reporting shout: " + err); }, false);
}

function buildShareMessage(desc, tags) {
    var msg = "I just sent a Shout Out!";

    if (desc.trim() != "")
        msg += " about " + desc + ".";
    if (tags.trim() != "")
        msg += " " + tags;

    return msg;
}

function deleteShout() {
    stopAllPlayback();
    serverRequest("POST", "/deletemessage", "MessageID=" + curMessageID, null,
    function (results) {
        $("#popupDeleteShout").popup("close");

        // remove it from the DOM
        $("#" + curHolderID).remove();
    }, true,
    function (err) { trunicaAlert("Error deleting shout: " + err); }, false);
}

function shoutOwnerInfo(TargetID) {
    serverRequest("GET", "/getuserinfo", "TargetID=" + TargetID, "Unable to get user profile.",
        function (results) {
            data = JSON.parse(results.responseText);

            $("#lblShowProfileUserName").html(data[0].UserName);
            $("#lblAbout").html(data[0].Description);
            if (data[0].hasPic != 0)
                $("#imgShowProfileImage").attr("src", SERVER_URL + SERVER_API_PATH + "/getprofileimage?token=" + accessToken +
                                               "&UserID=" + data[0].UserID + "&crc=" + data[0].PictureCRC);
            else
                $("#imgShowProfileImage").attr("src", "images/profileImage.png");
            $("#popupUserInfo").popup("open");
        }, true, function (err) { trunicaAlert("Error getting profile info: " + err); }, false);
}

function shoutToggleFavorite(MessageID, HolderID) {
    var icon = $("#fav-" + HolderID);
    var isFavorite = icon.attr("alt");
    
    if (isFavorite != "null")
        serverRequest("POST", "/removefavoritemessage", "MessageID=" + MessageID, "Error removing shout from favorites.",
            function (results) { icon.removeClass("favorite"); icon.attr("alt", "null"); }, true,
            function (err) { trunicaAlert("Could not remove shout from favorites: " + err); }, false);
    else
        serverRequest("POST", "/addfavoritemessage", "MessageID=" + MessageID, "Error adding to favorites",
            function (results) { icon.addClass("favorite"); icon.attr("alt", MessageID); }, true,
            function (err) { trunicaAlert("Could not add shout to favorites: " + err) }, false);
}
