﻿"use strict";
/// <reference path="globals.js" />
/// <reference path="utils.js" />
/// <reference path="auth.js" />
/// <reference path="servercomm.js" />
/// <reference path="jquery-2.1.4.js" />
/// <reference path="jquery.mobile-1.4.5.js" />
/// <reference path="shout.js" />
/// <reference path="sounds.js" />
/// <reference path="position.js" />
/// <reference path="profile.js" />

function readyUserInterface() {
    $("#popupShoutInfo").enhanceWithin().popup();
    $("#popupReShout").enhanceWithin().popup();
    $("#popupReport").enhanceWithin().popup();
    $("#popupUserInfo").enhanceWithin().popup();
    $("#popupDeleteShout").enhanceWithin().popup();
    $("#popupLoading").enhanceWithin().popup();
    $("#popupNotify").enhanceWithin().popup();

    $("#spanVersionNumber").html(APP_VERSION);

    $("#btnLogin").on("click", function () { login($("#txtUserName").val(), $("#txtPassword").val()); });
  
    $("#btnDoSignUp").on("click", function () {
        signUp($("#txtSignUpUserName").val(), $("#txtSignUpPassword").val(), $("#txtSignUpPasswordVerify").val(), $("#txtSignUpEmail").val());
    });
    
    $("#btnLogout").on("click", function () { logout(); });
    $("#btnLogoutAndroid").on("click", function () { logout(); });
    
    $("#btnForgot").on("click", function () { $("#popupBadLogin").popup("close"); setTimeout(function () { $("#popupForgot").popup("open"); }, 150); });

    $("#btnReset").on("click", function () { resetPassword(); });

    $("#btnRecord").on("click", function () { recordShout(); });

    $("#btnCancelShout").on("click", function () { cancelShout(); });

    $("#popupRecord").bind({
        popupbeforeposition: function (event, ui) { resetRecordWindow(); }
    });

    $("#btnUploadShout").on("click", function () { uploadShout(); });

    $("#btnReportShout").on("click", function () { reportShout(); });
    $("#btnDeleteShout").on("click", function () { deleteShout(); });
    $("#btnReshout").on("click", function () { reshoutShout() });

    $("#pageFavorites").on("pageshow", function () { loadFavorites("#lstFavorites"); });
    $("#pageMyShouts").on("pageshow", function () { loadMyShouts("#lstMyShouts"); });

    $("#imgProfileImage").on("click", selectProfileImage);
    $("#pageProfile").on("pageshow", loadProfileInfo);
    $("#txtProfileEmail").on("change", updateProfile);
    $("#txtProfileDescription").on("change", updateProfile);
    $("#btnChangePassword").on("click", changePassword);

    // stop audio playback on page transitions
    $("#pageHome").on("pageshow", function () { stopAllPlayback(); });
    $("#pageHome").on("pagehide", function () { stopAllPlayback(); });

    $("#pageSettings").on("pageinit", function () {
        $("#slideMiles").val(getDistanceSetting()).slider("refresh");
        $("#slideMiles").on("change", function () { setDistanceSetting($("#slideMiles").val()); });
    });

    //$("#popular").on("tap", function() { loadPopular(); });
    $("#pageHome").on("pageinit", function () {
        $("#navPopular").on("click", function () { loadPopular(); });
        $("#navCloseBy").on("click", function () { loadCloseBy(); });
        $("#navLatest").on("click", function () { loadLatest(); });
    });
    //$("#txtSearchField").on("change", function () { loadSearchToList("#lstSearch", " Likes DESC"); });
}

function resetUserInterface() {
    $("#txtUserName").val(null);
    $("#txtPassword").val(null);
    $("#txtSignUpUserName").val(null);
    $("#txtSignUpEmail").val(null);
    $("#txtSignUpPassword").val(null);
    $("#txtSignUpPasswordVerify").val(null);
    $("#txtSeachField").val(null);

    clearMessages("#popular");
    clearMessages("#latest");
    clearMessages("#closeBy");
    clearMessages("#lstFavorites");
    clearMessages("#lstMyShouts");
    clearMessages("#lstSearch");

    $("#imgProfileImage").attr("src", "images/profileImage70x70.png");
}